package com.bomostory.sceneeditmodule.navigationbar.actor

import android.content.ClipData
import android.content.ClipDescription
import android.content.Context
import android.support.v7.widget.LinearLayoutManager
import android.util.AttributeSet
import android.view.LayoutInflater
import android.view.MotionEvent
import android.view.View
import android.widget.ImageView
import android.widget.LinearLayout
import com.example.tfat.myapplication.R
import kotlinx.android.synthetic.main.object_select_view.view.*

class ObjectView: LinearLayout {

    constructor(context : Context) : super(context) {
        initView()
    }

    constructor(context: Context, attrs: AttributeSet): super(context, attrs) {
        initView()
    }

    constructor(context: Context, attrs: AttributeSet, defStyle: Int): super(context, attrs, defStyle) {
        initView()
    }

    private var objectData = ArrayList<String>()
    private var objectListeners = ArrayList<View.OnTouchListener>()
    private var objectAdapter = ObjectAdapter(objectData, objectListeners)

    private fun initView(){
        val inflater = LayoutInflater.from(context)
        inflater.inflate(R.layout.object_select_view, this, true)
    }

    fun setData(objectData: ArrayList<String>){
        rv_object_view.apply {
            adapter = objectAdapter
            layoutManager = LinearLayoutManager(context).apply {
                orientation = LinearLayoutManager.HORIZONTAL
            }
        }
        this.objectData.apply {
            clear()
            for (i in 0 until objectData.size){
                add(objectData[i])
            }
        }
        this.objectListeners.apply {
            clear()
            for (i in 0 until objectData.size){
                add(boMoOnTouchListener(objectData[i]))
            }
        }
        objectAdapter.notifyDataSetChanged()
    }
    private fun boMoOnTouchListener(resource: String) : View.OnTouchListener {
        return View.OnTouchListener { view, motionEvent ->
            when (motionEvent.action) {
                MotionEvent.ACTION_DOWN -> {
                    val item = ClipData.Item(resource)
                    val mimeTypes = arrayOf(ClipDescription.MIMETYPE_TEXT_PLAIN)
                    val dragData = ClipData(null, mimeTypes, item)
                    val shadow = View.DragShadowBuilder(view.findViewById<ImageView>(R.id.actor_image))
                    view.findViewById<ImageView>(R.id.actor_image).startDrag(dragData, shadow, null, View.DRAG_FLAG_GLOBAL)
                }
            }
            return@OnTouchListener true
        }
    }
}